//
//  UIButton+MTAdditions.m
//  scummvm
//
//  Created by Ilya Levin on 29/10/2015.
//
//

#import "UIButton+MTAdditions.h"
#import "UIFont+ScummVMAdditions.h"
#import "UIColor+MTAdditions.h"
#import "UIStoryboard+scummVMAdditions.h"
#import "GameInfo.h"

@implementation UIButton (MTAdditions)

-(void)configureWithTheme
{
    [self configureWithTheme:NO];
}

-(void)configureWithTheme:(BOOL)isPopupStyle
{
    if ((CURRENT_GAME_TYPE == GAME_TYPE_FOTAQ) || (CURRENT_GAME_TYPE == GAME_TYPE_SIMON1) || (CURRENT_GAME_TYPE == GAME_TYPE_SIMON2) || (CURRENT_GAME_TYPE == GAME_TYPE_T7G)) {
        
        if (!isPopupStyle || CURRENT_GAME_TYPE != GAME_TYPE_FOTAQ)
        {
            BOOL isIpad = [UIDevice currentDevice].userInterfaceIdiom == UIUserInterfaceIdiomPad;
            
            NSString* buttonPrefix = @"";
            switch (CURRENT_GAME_TYPE) {
                case GAME_TYPE_FOTAQ:
                    buttonPrefix = @"fotaq_";
                    break;
                case GAME_TYPE_SIMON1:
                    buttonPrefix = @"simon_";
                    break;
                case GAME_TYPE_SIMON2:
                    buttonPrefix = @"simon2_";
                    break;
                    
                default:
                    break;
            }
            
            
            [self setBackgroundImage:[UIImage imageNamed:[buttonPrefix stringByAppendingString:@"button"]] forState:UIControlStateNormal];
            [self setBackgroundImage:[UIImage imageNamed:[buttonPrefix stringByAppendingString:@"buttondisable"]] forState:UIControlStateDisabled];
            [self setBackgroundImage:[UIImage imageNamed:[buttonPrefix stringByAppendingString:@"buttonover"]] forState:UIControlStateSelected];
            
            
            if (CURRENT_GAME_TYPE == GAME_TYPE_SIMON1)
            {
                [self.superview addConstraints:[NSLayoutConstraint constraintsWithVisualFormat:@"H:[button(width)]" options:0 metrics:@{@"width":isIpad?@230:@(110 * [UIStoryboard relativeScale])} views:@{@"button":self}]];
                [self.superview addConstraints:[NSLayoutConstraint constraintsWithVisualFormat:@"V:[button(height)]" options:0 metrics:@{@"height":isIpad?@50:@(30 * [UIStoryboard relativeScale])} views:@{@"button":self}]];
            }
            else if (CURRENT_GAME_TYPE == GAME_TYPE_IHNM)
            {
                [self.superview addConstraints:[NSLayoutConstraint constraintsWithVisualFormat:@"H:[button(width)]" options:0 metrics:@{@"width":isIpad?@285:@(165 * [UIStoryboard relativeScale])} views:@{@"button":self}]];
                [self.superview addConstraints:[NSLayoutConstraint constraintsWithVisualFormat:@"V:[button(height)]" options:0 metrics:@{@"height":isIpad?@50:@(30 * [UIStoryboard relativeScale])} views:@{@"button":self}]];
            }
            else if (CURRENT_GAME_TYPE == GAME_TYPE_FOTAQ)
            {
                [self.superview addConstraints:[NSLayoutConstraint constraintsWithVisualFormat:@"H:[button(width)]" options:0 metrics:@{@"width":isIpad?@285:@(135 * [UIStoryboard relativeScale])} views:@{@"button":self}]];
                [self.superview addConstraints:[NSLayoutConstraint constraintsWithVisualFormat:@"V:[button(height)]" options:0 metrics:@{@"height":isIpad?@50:@(30 * [UIStoryboard relativeScale])} views:@{@"button":self}]];
            }
            
            self.adjustsImageWhenHighlighted = NO;
            self.adjustsImageWhenDisabled = NO;
        }
        self.titleLabel.textAlignment = NSTextAlignmentCenter;
        
        [self setContentHorizontalAlignment:UIControlContentHorizontalAlignmentCenter];

    }
    
    self.layer.masksToBounds = YES;
    self.titleLabel.clipsToBounds = NO;
    self.titleLabel.font = [UIFont mt_themeFontOfAppropriateSize];
    
    [self setTitleColor:[UIColor mt_mainButtonColor] forState:UIControlStateNormal];
    [self setTitleColor:[UIColor mt_selectedButtonColor] forState:UIControlStateHighlighted];
    [self setTitleColor:[UIColor mt_disabledButtonColor] forState:UIControlStateDisabled];
    [self setTitleShadowColor:[UIColor mt_mainshadowButtonColor] forState:UIControlStateNormal];
    [self setTitleShadowColor:[UIColor mt_selectedshadowButtonColor] forState:UIControlStateHighlighted];
    [self setTitleShadowColor:[UIColor mt_disabledshadowButtonColor] forState:UIControlStateDisabled];
    
    switch (CURRENT_GAME_TYPE) {
        case GAME_TYPE_IHNM:
            self.titleLabel.shadowOffset = CGSizeMake(1.0f, 1.0f);
            break;
            
        case GAME_TYPE_FOTAQ:
            self.titleLabel.shadowOffset = CGSizeMake(1.0f, 2.0f);
            break;
            
        case GAME_TYPE_SIMON1:
            self.titleLabel.shadowOffset = CGSizeMake(1.0f, 1.0f);
            break;
            
        case GAME_TYPE_SIMON2:
            self.titleLabel.shadowOffset = CGSizeMake(1.0f, 1.0f);
            break;
            
        case GAME_TYPE_T7G:
            self.titleLabel.shadowOffset = CGSizeMake(1.0f, 1.0f);
            break;
    }
}

@end
